﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace ExtentWFA
{
    public partial class frmMain : Form
    {
        public frmMain()
        {
            InitializeComponent();
        }
        private void LoopDir() {
            try
            {
                StreamWriter sw = new StreamWriter(File.Open("files.txt", FileMode.Create)); //smaze obsah souboru files.txt, kam se budou vypisovat informace o souborech
                sw.Close();
            }
            catch (Exception ex)
            {
                txtOutput.Text = ex.Message;
            }
            string[] files = Directory.GetFiles(txtFolderPath.Text, "*.shp", SearchOption.AllDirectories); //do pole files ulozi cesty k souborum s priponou shp, ktere se nachazeji v adresari uvedenem v poli txtFolderPath a v podadresrich
            for (int i = 0; i < files.Length; i++) { //prochazi vsechny soubory s priponou shp
                txtOutput.Text = "Processing " + files[i];
                WriteExtent(files[i]); //zpracuje kazdy ze souboru s priponou shp
            }
        }
        private void WriteExtent(String path)
        {
            try
            {
                BinaryReader br = new BinaryReader(File.OpenRead(path)); //reader pro cteni z ESRI shapefile
                StreamWriter sw = new StreamWriter(File.Open("files.txt", FileMode.Append)); //Informaci o aktualnim souboru shp budeme pridavat na konec souboru files.txt, proto mode Append
		//preskoci prvnich 9 integeru, ktere nas z hlavicky shp souboru nezajimaji
                for (int j = 0; j < 9; j++) 
                {
                    int i = br.ReadInt32();
                }
                double minx = br.ReadDouble(); //precte 37-44 byte obsahujici informaci o minx daneho shp souboru
                double miny = br.ReadDouble(); //precte 45-52 byte obsahujici informaci o miny daneho shp souboru
                double maxx = br.ReadDouble(); //precte 53-60 byte obsahujici informaci o maxx daneho shp souboru
                double maxy = br.ReadDouble(); //precte 61-68 byte obsahujici informaci o maxy daneho shp souboru
                sw.WriteLine(path + ";" + minx + ";" + miny + ";" + maxx + ";" + maxy); //zapise nazev souboru i s cestou a souradnice bounding boxu do souboru files.txt
                sw.Close(); //uzavre soubor files.txt, tim dojde k zapisu na disk
                br.Close(); //uzavre ceny shp soubor
            }
            catch (Exception ex) {
                txtOutput.Text = ex.Message;
            }
        }

        private void btnWriteExtent_Click(object sender, EventArgs e)
        {
            //WriteExtent(@"D:\voj76\Cviceni05_REFER\bud1_vsb.shp");
            LoopDir();
        }
    }
}
